searchNodes=[{"doc":"This is an SFTP Client that wraps Erlang's :ssh and :ssh_sftp libraries for easier usage in Elixir.Connect &amp; DisconnectTo open a new connection to an SFTP server:iex&gt; {:ok, conn} = SFTPClient.connect(host: &quot;ftp.myhost.com&quot;) {:ok, %SFTPClient.Conn{}}Refer to the docs for SFTPClient.Operations.Connect.connect/1 to find out all available options.It is strongly recommended to close a connection after your operations have completed:iex&gt; SFTPClient.disconnect(conn) :okFor short-lived connections you can also use a function as second argument. After the function body has run or raises, the connection is automatically closed.iex&gt; SFTPClient.connect([host: &quot;ftp.myhost.com&quot;], fn conn -&gt; ...&gt; # Do something with conn ...&gt; &quot;my result&quot; ...&gt; end) {:ok, &quot;my result&quot;}DownloadYou can download a file from the server you can use the following function.iex&gt; SFTPClient.download_file(conn, &quot;my/remote/dir/file.jpg&quot;, &quot;my/dir/local-file.jpg&quot;) {:ok, &quot;my/dir/local-file.jpg&quot;}When the third argument is an existing directory on your file system, the file is downloaded to a file with the same name as the one on the server.iex&gt; SFTPClient.download_file(conn, &quot;my/remote/dir/image.png&quot;, &quot;my/local/dir&quot;) {:ok, &quot;my/local/dir/image.png&quot;}It is also possible to use Streams to download data into a file or memory.iex&gt; SFTPClient.stream_file!(conn, &quot;my/remote/file.jpg&quot;) ...&gt; |&gt; Stream.into(File.stream!(&quot;my/local/file.jpg&quot;)) ...&gt; |&gt; Stream.run() :okUploadTo upload are file from the file system you can use the following function.iex&gt; SFTPClient.upload_file(conn, &quot;my/local/dir/file.jpg&quot;, &quot;my/remote/dir/file.jpg&quot;) {:ok, &quot;my/remote/dir/file.jpg&quot;}You can also use Streams to upload data. Please make sure to set a proper chunk size or the upload may be slow.iex&gt; File.stream!(&quot;my/local/file.jpg&quot;) ...&gt; |&gt; Stream.into(SFTPClient.stream_file!(conn, &quot;my/remote/file.jpg&quot;)) ...&gt; |&gt; Stream.run() :okList Directoryiex&gt; SFTPClient.list_dir(conn, &quot;my/dir&quot;) {:ok, [&quot;my/dir/file_1.jpg&quot;, &quot;my/dir/file_2.jpg&quot;]}Create Directoryiex&gt; SFTPClient.make_dir(conn, &quot;my/new/dir&quot;) :okNote that this operation fails unless the parent directory exists.DeleteTo delete a file:iex&gt; SFTPClient.delete_file(conn, &quot;my/remote/file.jpg&quot;) :okTo delete a directory:iex&gt; SFTPClient.delete_dir(conn, &quot;my/remote/dir&quot;) :okNote that a directory cannot be deleted as long as it still contains files.RenameTo move/rename a file or directory:iex&gt; SFTPClient.rename(conn, &quot;my/remote/file.jpg&quot;, &quot;my/remote/new-file.jpg&quot;) :okFile InfoYou can retrieve meta data about a file from the server such as file size, modification time, file permissions, owner and so on.iex&gt; SFTPClient.file_info(conn, &quot;my/remote/file.jpg&quot;) {:ok, %File.Stat{}}Refer to the File.Stat docs for a list of available file information.Symbolic LinksThere are also a couple of functions that handle symbolic links.It is possible to get the target of a symlink.iex&gt; SFTPClient.read_link(conn, &quot;my/remote/link.jpg&quot;) {:ok, &quot;my/remote/file.jpg&quot;}You can retrieve meta data about symlinks, similar to file_info/2.iex&gt; SFTPClient.link_info(conn, &quot;my/remote/link.jpg&quot;) {:ok, %File.Stat{}}And you are able to create symlinks.iex&gt; SFTPClient.make_link(conn, &quot;my/remote/link.jpg&quot;, &quot;my/remote/file.jpg&quot;) :ok","ref":"SFTPClient.html","title":"SFTPClient","type":"module"},{"doc":"See SFTPClient.Operations.CloseHandle.close_handle/1.","ref":"SFTPClient.html#close_handle/1","title":"SFTPClient.close_handle/1","type":"function"},{"doc":"See SFTPClient.Operations.CloseHandle.close_handle!/1.","ref":"SFTPClient.html#close_handle!/1","title":"SFTPClient.close_handle!/1","type":"function"},{"doc":"See SFTPClient.Operations.Connect.connect/1.","ref":"SFTPClient.html#connect/1","title":"SFTPClient.connect/1","type":"function"},{"doc":"See SFTPClient.Operations.Connect.connect/2.","ref":"SFTPClient.html#connect/2","title":"SFTPClient.connect/2","type":"function"},{"doc":"See SFTPClient.Operations.Connect.connect!/1.","ref":"SFTPClient.html#connect!/1","title":"SFTPClient.connect!/1","type":"function"},{"doc":"See SFTPClient.Operations.Connect.connect!/2.","ref":"SFTPClient.html#connect!/2","title":"SFTPClient.connect!/2","type":"function"},{"doc":"See SFTPClient.Operations.DeleteDir.delete_dir/2.","ref":"SFTPClient.html#delete_dir/2","title":"SFTPClient.delete_dir/2","type":"function"},{"doc":"See SFTPClient.Operations.DeleteDir.delete_dir!/2.","ref":"SFTPClient.html#delete_dir!/2","title":"SFTPClient.delete_dir!/2","type":"function"},{"doc":"See SFTPClient.Operations.DeleteFile.delete_file/2.","ref":"SFTPClient.html#delete_file/2","title":"SFTPClient.delete_file/2","type":"function"},{"doc":"See SFTPClient.Operations.DeleteFile.delete_file!/2.","ref":"SFTPClient.html#delete_file!/2","title":"SFTPClient.delete_file!/2","type":"function"},{"doc":"See SFTPClient.Operations.Disconnect.disconnect/1.","ref":"SFTPClient.html#disconnect/1","title":"SFTPClient.disconnect/1","type":"function"},{"doc":"See SFTPClient.Operations.DownloadFile.download_file/3.","ref":"SFTPClient.html#download_file/3","title":"SFTPClient.download_file/3","type":"function"},{"doc":"See SFTPClient.Operations.DownloadFile.download_file!/3.","ref":"SFTPClient.html#download_file!/3","title":"SFTPClient.download_file!/3","type":"function"},{"doc":"See SFTPClient.Operations.FileInfo.file_info/2.","ref":"SFTPClient.html#file_info/2","title":"SFTPClient.file_info/2","type":"function"},{"doc":"See SFTPClient.Operations.FileInfo.file_info!/2.","ref":"SFTPClient.html#file_info!/2","title":"SFTPClient.file_info!/2","type":"function"},{"doc":"See SFTPClient.Operations.LinkInfo.link_info/2.","ref":"SFTPClient.html#link_info/2","title":"SFTPClient.link_info/2","type":"function"},{"doc":"See SFTPClient.Operations.LinkInfo.link_info!/2.","ref":"SFTPClient.html#link_info!/2","title":"SFTPClient.link_info!/2","type":"function"},{"doc":"See SFTPClient.Operations.ListDir.list_dir/2.","ref":"SFTPClient.html#list_dir/2","title":"SFTPClient.list_dir/2","type":"function"},{"doc":"See SFTPClient.Operations.ListDir.list_dir!/2.","ref":"SFTPClient.html#list_dir!/2","title":"SFTPClient.list_dir!/2","type":"function"},{"doc":"See SFTPClient.Operations.MakeDir.make_dir/2.","ref":"SFTPClient.html#make_dir/2","title":"SFTPClient.make_dir/2","type":"function"},{"doc":"See SFTPClient.Operations.MakeDir.make_dir!/2.","ref":"SFTPClient.html#make_dir!/2","title":"SFTPClient.make_dir!/2","type":"function"},{"doc":"See SFTPClient.Operations.MakeLink.make_link/3.","ref":"SFTPClient.html#make_link/3","title":"SFTPClient.make_link/3","type":"function"},{"doc":"See SFTPClient.Operations.MakeLink.make_link!/3.","ref":"SFTPClient.html#make_link!/3","title":"SFTPClient.make_link!/3","type":"function"},{"doc":"See SFTPClient.Operations.OpenDir.open_dir/2.","ref":"SFTPClient.html#open_dir/2","title":"SFTPClient.open_dir/2","type":"function"},{"doc":"See SFTPClient.Operations.OpenDir.open_dir/3.","ref":"SFTPClient.html#open_dir/3","title":"SFTPClient.open_dir/3","type":"function"},{"doc":"See SFTPClient.Operations.OpenDir.open_dir!/2.","ref":"SFTPClient.html#open_dir!/2","title":"SFTPClient.open_dir!/2","type":"function"},{"doc":"See SFTPClient.Operations.OpenDir.open_dir!/3.","ref":"SFTPClient.html#open_dir!/3","title":"SFTPClient.open_dir!/3","type":"function"},{"doc":"See SFTPClient.Operations.OpenFile.open_file/3.","ref":"SFTPClient.html#open_file/3","title":"SFTPClient.open_file/3","type":"function"},{"doc":"See SFTPClient.Operations.OpenFile.open_file/4.","ref":"SFTPClient.html#open_file/4","title":"SFTPClient.open_file/4","type":"function"},{"doc":"See SFTPClient.Operations.OpenFile.open_file!/3.","ref":"SFTPClient.html#open_file!/3","title":"SFTPClient.open_file!/3","type":"function"},{"doc":"See SFTPClient.Operations.OpenFile.open_file!/4.","ref":"SFTPClient.html#open_file!/4","title":"SFTPClient.open_file!/4","type":"function"},{"doc":"See SFTPClient.Operations.ReadDir.read_dir/1.","ref":"SFTPClient.html#read_dir/1","title":"SFTPClient.read_dir/1","type":"function"},{"doc":"See SFTPClient.Operations.ReadDir.read_dir!/1.","ref":"SFTPClient.html#read_dir!/1","title":"SFTPClient.read_dir!/1","type":"function"},{"doc":"See SFTPClient.Operations.ReadFile.read_file/2.","ref":"SFTPClient.html#read_file/2","title":"SFTPClient.read_file/2","type":"function"},{"doc":"See SFTPClient.Operations.ReadFile.read_file!/2.","ref":"SFTPClient.html#read_file!/2","title":"SFTPClient.read_file!/2","type":"function"},{"doc":"See SFTPClient.Operations.ReadFileChunk.read_file_chunk/2.","ref":"SFTPClient.html#read_file_chunk/2","title":"SFTPClient.read_file_chunk/2","type":"function"},{"doc":"See SFTPClient.Operations.ReadFileChunk.read_file_chunk!/2.","ref":"SFTPClient.html#read_file_chunk!/2","title":"SFTPClient.read_file_chunk!/2","type":"function"},{"doc":"See SFTPClient.Operations.ReadLink.read_link/2.","ref":"SFTPClient.html#read_link/2","title":"SFTPClient.read_link/2","type":"function"},{"doc":"See SFTPClient.Operations.ReadLink.read_link!/2.","ref":"SFTPClient.html#read_link!/2","title":"SFTPClient.read_link!/2","type":"function"},{"doc":"See SFTPClient.Operations.Rename.rename/3.","ref":"SFTPClient.html#rename/3","title":"SFTPClient.rename/3","type":"function"},{"doc":"See SFTPClient.Operations.Rename.rename!/3.","ref":"SFTPClient.html#rename!/3","title":"SFTPClient.rename!/3","type":"function"},{"doc":"See SFTPClient.Operations.StreamFile.stream_file/2.","ref":"SFTPClient.html#stream_file/2","title":"SFTPClient.stream_file/2","type":"function"},{"doc":"See SFTPClient.Operations.StreamFile.stream_file/3.","ref":"SFTPClient.html#stream_file/3","title":"SFTPClient.stream_file/3","type":"function"},{"doc":"See SFTPClient.Operations.StreamFile.stream_file!/2.","ref":"SFTPClient.html#stream_file!/2","title":"SFTPClient.stream_file!/2","type":"function"},{"doc":"See SFTPClient.Operations.StreamFile.stream_file!/3.","ref":"SFTPClient.html#stream_file!/3","title":"SFTPClient.stream_file!/3","type":"function"},{"doc":"See SFTPClient.Operations.UploadFile.upload_file/3.","ref":"SFTPClient.html#upload_file/3","title":"SFTPClient.upload_file/3","type":"function"},{"doc":"See SFTPClient.Operations.UploadFile.upload_file!/3.","ref":"SFTPClient.html#upload_file!/3","title":"SFTPClient.upload_file!/3","type":"function"},{"doc":"See SFTPClient.Operations.WriteFile.write_file/3.","ref":"SFTPClient.html#write_file/3","title":"SFTPClient.write_file/3","type":"function"},{"doc":"See SFTPClient.Operations.WriteFile.write_file!/3.","ref":"SFTPClient.html#write_file!/3","title":"SFTPClient.write_file!/3","type":"function"},{"doc":"See SFTPClient.Operations.WriteFileChunk.write_file_chunk/2.","ref":"SFTPClient.html#write_file_chunk/2","title":"SFTPClient.write_file_chunk/2","type":"function"},{"doc":"See SFTPClient.Operations.WriteFileChunk.write_file_chunk!/2.","ref":"SFTPClient.html#write_file_chunk!/2","title":"SFTPClient.write_file_chunk!/2","type":"function"},{"doc":"File access modes that can be used when opening files directly from the remote server.","ref":"SFTPClient.html#t:access_mode/0","title":"SFTPClient.access_mode/0","type":"type"},{"doc":"A type incorporating all error types.","ref":"SFTPClient.html#t:error/0","title":"SFTPClient.error/0","type":"type"},{"doc":"A module containing the connection configuration.","ref":"SFTPClient.Config.html","title":"SFTPClient.Config","type":"module"},{"doc":"Builds a config from the given SFTPClient.Config struct, keyword list or map.","ref":"SFTPClient.Config.html#new/1","title":"SFTPClient.Config.new/1","type":"function"},{"doc":"","ref":"SFTPClient.Config.html#t:t/0","title":"SFTPClient.Config.t/0","type":"type"},{"doc":"A struct containing connection-specific information.","ref":"SFTPClient.Conn.html","title":"SFTPClient.Conn","type":"module"},{"doc":"","ref":"SFTPClient.Conn.html#t:t/0","title":"SFTPClient.Conn.t/0","type":"type"},{"doc":"A struct that represents a directory entry on a remote server, containing the filename, full path and meta data.","ref":"SFTPClient.Entry.html","title":"SFTPClient.Entry","type":"module"},{"doc":"","ref":"SFTPClient.Entry.html#t:t/0","title":"SFTPClient.Entry.t/0","type":"type"},{"doc":"A struct that contains a connection and handle ID that points to a file or directory on the remote server.","ref":"SFTPClient.Handle.html","title":"SFTPClient.Handle","type":"module"},{"doc":"","ref":"SFTPClient.Handle.html#t:t/0","title":"SFTPClient.Handle.t/0","type":"type"},{"doc":"A provider that loads keys for authentication from the given location. Implements the :ssh_client_key_api behavior.","ref":"SFTPClient.KeyProvider.html","title":"SFTPClient.KeyProvider","type":"module"},{"doc":"A module that provides functions to upload files to an SFTP server.","ref":"SFTPClient.Operations.UploadFile.html","title":"SFTPClient.Operations.UploadFile","type":"module"},{"doc":"Uploads a file from the file system to the server.","ref":"SFTPClient.Operations.UploadFile.html#upload_file/3","title":"SFTPClient.Operations.UploadFile.upload_file/3","type":"function"},{"doc":"Uploads a file from the file system to the server. Raises when the operation fails.","ref":"SFTPClient.Operations.UploadFile.html#upload_file!/3","title":"SFTPClient.Operations.UploadFile.upload_file!/3","type":"function"},{"doc":"A struct that contains file and directory meta data.","ref":"SFTPClient.SSHXferAttr.html","title":"SFTPClient.SSHXferAttr","type":"module"},{"doc":"Converts a record of the :ssh_xfer_attr type into this struct.","ref":"SFTPClient.SSHXferAttr.html#from_record/1","title":"SFTPClient.SSHXferAttr.from_record/1","type":"function"},{"doc":"","ref":"SFTPClient.SSHXferAttr.html#t:t/0","title":"SFTPClient.SSHXferAttr.t/0","type":"type"},{"doc":"A stream pointing to a file on an SFTP server. Implements the Enumerable and Collectable protocols.","ref":"SFTPClient.Stream.html","title":"SFTPClient.Stream","type":"module"},{"doc":"Gets a stream that reads a file from the remote server in chunks.","ref":"SFTPClient.Stream.html#readable_stream/1","title":"SFTPClient.Stream.readable_stream/1","type":"function"},{"doc":"","ref":"SFTPClient.Stream.html#t:t/0","title":"SFTPClient.Stream.t/0","type":"type"},{"doc":"A behavior that defines required callbacks for a low-level SFTP adapter.","ref":"SFTPClient.Adapter.SFTP.html","title":"SFTPClient.Adapter.SFTP","type":"behaviour"},{"doc":"","ref":"SFTPClient.Adapter.SFTP.html#c:close/3","title":"SFTPClient.Adapter.SFTP.close/3","type":"callback"},{"doc":"","ref":"SFTPClient.Adapter.SFTP.html#c:del_dir/3","title":"SFTPClient.Adapter.SFTP.del_dir/3","type":"callback"},{"doc":"","ref":"SFTPClient.Adapter.SFTP.html#c:delete/3","title":"SFTPClient.Adapter.SFTP.delete/3","type":"callback"},{"doc":"","ref":"SFTPClient.Adapter.SFTP.html#c:list_dir/3","title":"SFTPClient.Adapter.SFTP.list_dir/3","type":"callback"},{"doc":"","ref":"SFTPClient.Adapter.SFTP.html#c:make_dir/3","title":"SFTPClient.Adapter.SFTP.make_dir/3","type":"callback"},{"doc":"","ref":"SFTPClient.Adapter.SFTP.html#c:make_link/4","title":"SFTPClient.Adapter.SFTP.make_link/4","type":"callback"},{"doc":"","ref":"SFTPClient.Adapter.SFTP.html#c:open/4","title":"SFTPClient.Adapter.SFTP.open/4","type":"callback"},{"doc":"","ref":"SFTPClient.Adapter.SFTP.html#c:opendir/3","title":"SFTPClient.Adapter.SFTP.opendir/3","type":"callback"},{"doc":"","ref":"SFTPClient.Adapter.SFTP.html#c:read/4","title":"SFTPClient.Adapter.SFTP.read/4","type":"callback"},{"doc":"","ref":"SFTPClient.Adapter.SFTP.html#c:read_file/3","title":"SFTPClient.Adapter.SFTP.read_file/3","type":"callback"},{"doc":"","ref":"SFTPClient.Adapter.SFTP.html#c:read_file_info/3","title":"SFTPClient.Adapter.SFTP.read_file_info/3","type":"callback"},{"doc":"","ref":"SFTPClient.Adapter.SFTP.html#c:read_link/3","title":"SFTPClient.Adapter.SFTP.read_link/3","type":"callback"},{"doc":"","ref":"SFTPClient.Adapter.SFTP.html#c:read_link_info/3","title":"SFTPClient.Adapter.SFTP.read_link_info/3","type":"callback"},{"doc":"","ref":"SFTPClient.Adapter.SFTP.html#c:readdir/3","title":"SFTPClient.Adapter.SFTP.readdir/3","type":"callback"},{"doc":"","ref":"SFTPClient.Adapter.SFTP.html#c:rename/4","title":"SFTPClient.Adapter.SFTP.rename/4","type":"callback"},{"doc":"","ref":"SFTPClient.Adapter.SFTP.html#c:start_channel/3","title":"SFTPClient.Adapter.SFTP.start_channel/3","type":"callback"},{"doc":"","ref":"SFTPClient.Adapter.SFTP.html#c:stop_channel/1","title":"SFTPClient.Adapter.SFTP.stop_channel/1","type":"callback"},{"doc":"","ref":"SFTPClient.Adapter.SFTP.html#c:write/4","title":"SFTPClient.Adapter.SFTP.write/4","type":"callback"},{"doc":"","ref":"SFTPClient.Adapter.SFTP.html#c:write_file/4","title":"SFTPClient.Adapter.SFTP.write_file/4","type":"callback"},{"doc":"A behavior that defines required callbacks for a low-level SSH adapter.","ref":"SFTPClient.Adapter.SSH.html","title":"SFTPClient.Adapter.SSH","type":"behaviour"},{"doc":"","ref":"SFTPClient.Adapter.SSH.html#c:close/1","title":"SFTPClient.Adapter.SSH.close/1","type":"callback"},{"doc":"A module that provides functions to close an open handle pointing to a file or directory on the SFTP server.","ref":"SFTPClient.Operations.CloseHandle.html","title":"SFTPClient.Operations.CloseHandle","type":"module"},{"doc":"Closes a handle to an open file or directory on the server.","ref":"SFTPClient.Operations.CloseHandle.html#close_handle/1","title":"SFTPClient.Operations.CloseHandle.close_handle/1","type":"function"},{"doc":"Closes a handle to an open file or directory on the server. Raises when the operation fails.","ref":"SFTPClient.Operations.CloseHandle.html#close_handle!/1","title":"SFTPClient.Operations.CloseHandle.close_handle!/1","type":"function"},{"doc":"A module containing operations to connect to an SSH/SFTP server.","ref":"SFTPClient.Operations.Connect.html","title":"SFTPClient.Operations.Connect","type":"module"},{"doc":"Connects to an SSH server and opens an SFTP channel.Options:host (required) - The host of the SFTP server.:port - The port of the SFTP server, defaults to 22.:user - The user to authenticate as, when omitted tries to determine the current user.:password - The password for the user.:user_dir - The directory to read private keys from.:dsa_pass_phrase - The passphrase for an DSA private key from the specified user dir.:rsa_pass_phrase - The passphrase for an RSA private key from the specified user dir.:ecdsa_pass_phrase - The passphrase for an ECDSA private key from the specified user dir.:private_key_path - The path to the private key to use for authentication.:private_key_pass_phrase - The passphrase that is used to decrypt the specified private key.:inet - The IP version to use, either :inet (default) or :inet6.:sftp_vsn - The SFTP version to be used.:connect_timeout - The connection timeout in milliseconds (defaults to 5000 ms), can be set to :infinity to disable timeout.:operation_timeout - The operation timeout in milliseconds (defaults to 5000 ms), can be set to :infinity to disable timeout.:key_cb - A 2-item tuple containing:A module that implements :ssh_client_key_api behaviour.:ssh_client_key_api behaviour opts.:modify_algorithms - An option passed to the underlying Erlang SSH implementation to support non-OTP default encryption algorithms. To re-enable diffie-hellman-group1-sha1, removed in OTP 23, pass: modify_algorithms: [append: [kex: [:&quot;diffie-hellman-group1-sha1&quot;]]]","ref":"SFTPClient.Operations.Connect.html#connect/1","title":"SFTPClient.Operations.Connect.connect/1","type":"function"},{"doc":"Connects to an SSH server and opens an SFTP channel, then runs the function and closes the connection when finished. Accepts the same options as connect/1.","ref":"SFTPClient.Operations.Connect.html#connect/2","title":"SFTPClient.Operations.Connect.connect/2","type":"function"},{"doc":"Connects to an SSH server and opens an SFTP channel. Accepts the same options as connect/1. Raises when the connection fails.","ref":"SFTPClient.Operations.Connect.html#connect!/1","title":"SFTPClient.Operations.Connect.connect!/1","type":"function"},{"doc":"Connects to an SSH server and opens an SFTP channel, then runs the function and closes the connection when finished. Accepts the same options as connect/1. Raises when the connection fails.","ref":"SFTPClient.Operations.Connect.html#connect!/2","title":"SFTPClient.Operations.Connect.connect!/2","type":"function"},{"doc":"A module containing operations to delete a directory from the remote server.","ref":"SFTPClient.Operations.DeleteDir.html","title":"SFTPClient.Operations.DeleteDir","type":"module"},{"doc":"Deletes the directory specified by path.","ref":"SFTPClient.Operations.DeleteDir.html#delete_dir/2","title":"SFTPClient.Operations.DeleteDir.delete_dir/2","type":"function"},{"doc":"Deletes the directory specified by path. Raises when the operation fails.","ref":"SFTPClient.Operations.DeleteDir.html#delete_dir!/2","title":"SFTPClient.Operations.DeleteDir.delete_dir!/2","type":"function"},{"doc":"A module containing operations to delete a file from the remote server.","ref":"SFTPClient.Operations.DeleteFile.html","title":"SFTPClient.Operations.DeleteFile","type":"module"},{"doc":"Deletes the file specified by path.","ref":"SFTPClient.Operations.DeleteFile.html#delete_file/2","title":"SFTPClient.Operations.DeleteFile.delete_file/2","type":"function"},{"doc":"Deletes the file specified by path. Raises when the operation fails.","ref":"SFTPClient.Operations.DeleteFile.html#delete_file!/2","title":"SFTPClient.Operations.DeleteFile.delete_file!/2","type":"function"},{"doc":"A module containing operations to disconnect from an SSH/SFTP server.","ref":"SFTPClient.Operations.Disconnect.html","title":"SFTPClient.Operations.Disconnect","type":"module"},{"doc":"Stops an SFTP channel and closes the SSH connection.","ref":"SFTPClient.Operations.Disconnect.html#disconnect/1","title":"SFTPClient.Operations.Disconnect.disconnect/1","type":"function"},{"doc":"A module that provides functions to download files from an SFTP server.","ref":"SFTPClient.Operations.DownloadFile.html","title":"SFTPClient.Operations.DownloadFile","type":"module"},{"doc":"Downloads a file from the remote path and stores it in the given local path. When the local path is a directory, the file name of the local file is inferred from the remote path.","ref":"SFTPClient.Operations.DownloadFile.html#download_file/3","title":"SFTPClient.Operations.DownloadFile.download_file/3","type":"function"},{"doc":"Downloads a file from the remote path and stores it in the given local path. When the local path is a directory, the file name of the local file is inferred from the remote path. Raises when the operation fails.","ref":"SFTPClient.Operations.DownloadFile.html#download_file!/3","title":"SFTPClient.Operations.DownloadFile.download_file!/3","type":"function"},{"doc":"A module that provides functions to retrieve information on files and directories from an SFTP server.","ref":"SFTPClient.Operations.FileInfo.html","title":"SFTPClient.Operations.FileInfo","type":"module"},{"doc":"Returns a File.Stat struct from the remote file system object specified by path.","ref":"SFTPClient.Operations.FileInfo.html#file_info/2","title":"SFTPClient.Operations.FileInfo.file_info/2","type":"function"},{"doc":"Returns a File.Stat struct from the remote file system object specified by path. Raises when the operation fails.","ref":"SFTPClient.Operations.FileInfo.html#file_info!/2","title":"SFTPClient.Operations.FileInfo.file_info!/2","type":"function"},{"doc":"A module that provides functions to retrieve information on symbolic links from an SFTP server.","ref":"SFTPClient.Operations.LinkInfo.html","title":"SFTPClient.Operations.LinkInfo","type":"module"},{"doc":"Returns a File.Stat struct from the remote symbolic link object specified by path.","ref":"SFTPClient.Operations.LinkInfo.html#link_info/2","title":"SFTPClient.Operations.LinkInfo.link_info/2","type":"function"},{"doc":"Returns a File.Stat struct from the remote symbolic link object specified by path. Raises when the operation fails.","ref":"SFTPClient.Operations.LinkInfo.html#link_info!/2","title":"SFTPClient.Operations.LinkInfo.link_info!/2","type":"function"},{"doc":"A module that provides functions to retrieve a list of files in the given directory from an SFTP server.","ref":"SFTPClient.Operations.ListDir.html","title":"SFTPClient.Operations.ListDir","type":"module"},{"doc":"Lists the given directory on the server, returning the filenames as a list of strings.","ref":"SFTPClient.Operations.ListDir.html#list_dir/2","title":"SFTPClient.Operations.ListDir.list_dir/2","type":"function"},{"doc":"Lists the given directory on the server, returning the filenames as a list of strings. Raises when the operation fails.","ref":"SFTPClient.Operations.ListDir.html#list_dir!/2","title":"SFTPClient.Operations.ListDir.list_dir!/2","type":"function"},{"doc":"A module that provides functions to create directories on an SFTP server.","ref":"SFTPClient.Operations.MakeDir.html","title":"SFTPClient.Operations.MakeDir","type":"module"},{"doc":"Creates a directory specified by path. The path must be a full path to a new directory. The directory can only be created in an existing directory.","ref":"SFTPClient.Operations.MakeDir.html#make_dir/2","title":"SFTPClient.Operations.MakeDir.make_dir/2","type":"function"},{"doc":"Creates a directory specified by path. The path must be a full path to a new directory. The directory can only be created in an existing directory. Raises when the operation fails.","ref":"SFTPClient.Operations.MakeDir.html#make_dir!/2","title":"SFTPClient.Operations.MakeDir.make_dir!/2","type":"function"},{"doc":"A module that provides functions to create symlinks on an SFTP server.","ref":"SFTPClient.Operations.MakeLink.html","title":"SFTPClient.Operations.MakeLink","type":"module"},{"doc":"Creates a symbolic link pointing to target_path with the name symlink_path.","ref":"SFTPClient.Operations.MakeLink.html#make_link/3","title":"SFTPClient.Operations.MakeLink.make_link/3","type":"function"},{"doc":"Creates a symbolic link pointing to target_path with the name symlink_path. Raises when the operation fails.","ref":"SFTPClient.Operations.MakeLink.html#make_link!/3","title":"SFTPClient.Operations.MakeLink.make_link!/3","type":"function"},{"doc":"A module that provides functions to open a directory on an SFTP server in order to list their contents.","ref":"SFTPClient.Operations.OpenDir.html","title":"SFTPClient.Operations.OpenDir","type":"module"},{"doc":"Opens a handle to a directory on the server. The handle can be used for reading directory contents.","ref":"SFTPClient.Operations.OpenDir.html#open_dir/2","title":"SFTPClient.Operations.OpenDir.open_dir/2","type":"function"},{"doc":"Opens a handle to a directory on the server. The handle can be used for reading directory contents. Then runs the function and closes the handle when finished.","ref":"SFTPClient.Operations.OpenDir.html#open_dir/3","title":"SFTPClient.Operations.OpenDir.open_dir/3","type":"function"},{"doc":"Opens a handle to a directory on the server. The handle can be used for reading directory contents. Raises when the operation fails.","ref":"SFTPClient.Operations.OpenDir.html#open_dir!/2","title":"SFTPClient.Operations.OpenDir.open_dir!/2","type":"function"},{"doc":"Opens a handle to a directory on the server. The handle can be used for reading directory contents. Then runs the function and closes the handle when finished. Raises when the operation fails.","ref":"SFTPClient.Operations.OpenDir.html#open_dir!/3","title":"SFTPClient.Operations.OpenDir.open_dir!/3","type":"function"},{"doc":"A module that provides functions to open a file on an SFTP server in order to read their contents.","ref":"SFTPClient.Operations.OpenFile.html","title":"SFTPClient.Operations.OpenFile","type":"module"},{"doc":"Opens a file on the server and returns a handle, which can be used for reading or writing.","ref":"SFTPClient.Operations.OpenFile.html#open_file/3","title":"SFTPClient.Operations.OpenFile.open_file/3","type":"function"},{"doc":"Opens a file on the server and returns a handle, which can be used for reading or writing, then runs the function and closes the handle when finished.","ref":"SFTPClient.Operations.OpenFile.html#open_file/4","title":"SFTPClient.Operations.OpenFile.open_file/4","type":"function"},{"doc":"Opens a file on the server and returns a handle, which can be used for reading or writing. Raises when the operation fails.","ref":"SFTPClient.Operations.OpenFile.html#open_file!/3","title":"SFTPClient.Operations.OpenFile.open_file!/3","type":"function"},{"doc":"Opens a file on the server and returns a handle, which can be used for reading or writing, then runs the function and closes the handle when finished. Raises when the operation fails.","ref":"SFTPClient.Operations.OpenFile.html#open_file!/4","title":"SFTPClient.Operations.OpenFile.open_file!/4","type":"function"},{"doc":"A module that provides functions to read a list of directories on an SFTP server from a given file handle.","ref":"SFTPClient.Operations.ReadDir.html","title":"SFTPClient.Operations.ReadDir","type":"module"},{"doc":"Reads the directory contents from the server, and returns the data as String.","ref":"SFTPClient.Operations.ReadDir.html#read_dir/1","title":"SFTPClient.Operations.ReadDir.read_dir/1","type":"function"},{"doc":"Reads a file from the server, and returns the data as String. Raises when the operation fails.","ref":"SFTPClient.Operations.ReadDir.html#read_dir!/1","title":"SFTPClient.Operations.ReadDir.read_dir!/1","type":"function"},{"doc":"A module that provides functions to read file contents from an SFTP server.","ref":"SFTPClient.Operations.ReadFile.html","title":"SFTPClient.Operations.ReadFile","type":"module"},{"doc":"Reads a file from the server, and returns the data as String.","ref":"SFTPClient.Operations.ReadFile.html#read_file/2","title":"SFTPClient.Operations.ReadFile.read_file/2","type":"function"},{"doc":"Reads a file from the server, and returns the data as String. Raises when the operation fails.","ref":"SFTPClient.Operations.ReadFile.html#read_file!/2","title":"SFTPClient.Operations.ReadFile.read_file!/2","type":"function"},{"doc":"A module that provides functions to read chunks of data from a file on an SFTP server.","ref":"SFTPClient.Operations.ReadFileChunk.html","title":"SFTPClient.Operations.ReadFileChunk","type":"module"},{"doc":"Reads the given number of bytes (length) from the file referenced by handle. If the file is read past eof, only the remaining bytes are read and returned. If no bytes are read, :eof is returned.","ref":"SFTPClient.Operations.ReadFileChunk.html#read_file_chunk/2","title":"SFTPClient.Operations.ReadFileChunk.read_file_chunk/2","type":"function"},{"doc":"Reads the given number of bytes (length) from the file referenced by handle. If the file is read past eof, only the remaining bytes are read and returned. If no bytes are read, :eof is returned. Raises when the operation fails.","ref":"SFTPClient.Operations.ReadFileChunk.html#read_file_chunk!/2","title":"SFTPClient.Operations.ReadFileChunk.read_file_chunk!/2","type":"function"},{"doc":"A module that provides functions to retrieve the target of a symbolic link on an SFTP server.","ref":"SFTPClient.Operations.ReadLink.html","title":"SFTPClient.Operations.ReadLink","type":"module"},{"doc":"Reads the link target from the symbolic link specified by path.","ref":"SFTPClient.Operations.ReadLink.html#read_link/2","title":"SFTPClient.Operations.ReadLink.read_link/2","type":"function"},{"doc":"Reads the link target from the symbolic link specified by path. Raises when the operation fails.","ref":"SFTPClient.Operations.ReadLink.html#read_link!/2","title":"SFTPClient.Operations.ReadLink.read_link!/2","type":"function"},{"doc":"A module that provides functions to rename files and directories on an SFTP server.","ref":"SFTPClient.Operations.Rename.html","title":"SFTPClient.Operations.Rename","type":"module"},{"doc":"Renames a file named old_path and gives it the name specified by new_path.","ref":"SFTPClient.Operations.Rename.html#rename/3","title":"SFTPClient.Operations.Rename.rename/3","type":"function"},{"doc":"Renames a file named old_path and gives it the name specified by new_path. Raises when the operation fails.","ref":"SFTPClient.Operations.Rename.html#rename!/3","title":"SFTPClient.Operations.Rename.rename!/3","type":"function"},{"doc":"A module that provides functions to create streams from and to files on an SFTP server.","ref":"SFTPClient.Operations.StreamFile.html","title":"SFTPClient.Operations.StreamFile","type":"module"},{"doc":"Creates a stream that allows reading from and writing to the server.","ref":"SFTPClient.Operations.StreamFile.html#stream_file/2","title":"SFTPClient.Operations.StreamFile.stream_file/2","type":"function"},{"doc":"Creates a stream that allows reading from and writing to the server using the specified chunk size.","ref":"SFTPClient.Operations.StreamFile.html#stream_file/3","title":"SFTPClient.Operations.StreamFile.stream_file/3","type":"function"},{"doc":"Creates a stream that allows reading from and writing to the server.","ref":"SFTPClient.Operations.StreamFile.html#stream_file!/2","title":"SFTPClient.Operations.StreamFile.stream_file!/2","type":"function"},{"doc":"Creates a stream that allows reading from and writing to the server using the specified chunk size.","ref":"SFTPClient.Operations.StreamFile.html#stream_file!/3","title":"SFTPClient.Operations.StreamFile.stream_file!/3","type":"function"},{"doc":"A module that provides functions to write file contents to an SFTP server.","ref":"SFTPClient.Operations.WriteFile.html","title":"SFTPClient.Operations.WriteFile","type":"module"},{"doc":"Writes a file to the given path on the connected server.","ref":"SFTPClient.Operations.WriteFile.html#write_file/3","title":"SFTPClient.Operations.WriteFile.write_file/3","type":"function"},{"doc":"Writes a file to the given path on the connected server. Raises when the operation fails.","ref":"SFTPClient.Operations.WriteFile.html#write_file!/3","title":"SFTPClient.Operations.WriteFile.write_file!/3","type":"function"},{"doc":"A module that provides functions to write chunks of data to a file on an SFTP server.","ref":"SFTPClient.Operations.WriteFileChunk.html","title":"SFTPClient.Operations.WriteFileChunk","type":"module"},{"doc":"Writes data to the file referenced by handle. The file is to be opened with write or append flag.","ref":"SFTPClient.Operations.WriteFileChunk.html#write_file_chunk/2","title":"SFTPClient.Operations.WriteFileChunk.write_file_chunk/2","type":"function"},{"doc":"Writes data to the file referenced by handle. The file is to be opened with write or append flag. Raises when the operation fails.","ref":"SFTPClient.Operations.WriteFileChunk.html#write_file_chunk!/2","title":"SFTPClient.Operations.WriteFileChunk.write_file_chunk!/2","type":"function"},{"doc":"An error that is raised when connection to the SFTP server failed.","ref":"SFTPClient.ConnError.html","title":"SFTPClient.ConnError","type":"exception"},{"doc":"","ref":"SFTPClient.ConnError.html#t:t/0","title":"SFTPClient.ConnError.t/0","type":"type"},{"doc":"An error that is raised when the configuration contains invalid options.","ref":"SFTPClient.InvalidOptionError.html","title":"SFTPClient.InvalidOptionError","type":"exception"},{"doc":"Callback implementation for Exception.message/1.","ref":"SFTPClient.InvalidOptionError.html#message/1","title":"SFTPClient.InvalidOptionError.message/1","type":"function"},{"doc":"","ref":"SFTPClient.InvalidOptionError.html#t:t/0","title":"SFTPClient.InvalidOptionError.t/0","type":"type"},{"doc":"An error that is raised when an operation failed.","ref":"SFTPClient.OperationError.html","title":"SFTPClient.OperationError","type":"exception"},{"doc":"Callback implementation for Exception.message/1.","ref":"SFTPClient.OperationError.html#message/1","title":"SFTPClient.OperationError.message/1","type":"function"},{"doc":"","ref":"SFTPClient.OperationError.html#t:t/0","title":"SFTPClient.OperationError.t/0","type":"type"},{"doc":"SFTP Client An Elixir SFTP Client that wraps Erlang's ssh and ssh_sftp.","ref":"readme.html","title":"SFTP Client","type":"extras"},{"doc":"Erlang 20 or greaterElixir 1.8 or greater","ref":"readme.html#prerequisites","title":"SFTP Client - Prerequisites","type":"extras"},{"doc":"If available in Hex, the package can be installed by adding sftp_client to your list of dependencies in mix.exs:def deps do [ {:sftp_client, &quot;~&gt; 1.4&quot;} ] end","ref":"readme.html#installation","title":"SFTP Client - Installation","type":"extras"},{"doc":"There are bang (!) counterparts for almost all available functions.Connect &amp; DisconnectTo open a new connection to an SFTP server:{:ok, conn} = SFTPClient.connect(host: &quot;ftp.myhost.com&quot;)Refer to the docs for SFTPClient.Operations.Connect.connect/1 to find out all available options.It is strongly recommended to close a connection after your operations have completed:SFTPClient.disconnect(conn)For short-lived connections you can also use a function as second argument. After the function body has run or raises, the connection is automatically closed.SFTPClient.connect([host: &quot;ftp.myhost.com&quot;], fn conn -&gt; # Do something with conn end)DownloadTo download a file from the server you can use the following function.SFTPClient.download_file(conn, &quot;my/remote/dir/file.jpg&quot;, &quot;my/dir/local-file.jpg&quot;) # =&gt; {:ok, &quot;my/dir/local-file.jpg&quot;}When the third argument is an existing directory on your file system, the file is downloaded to a file with the same name as the one on the server.SFTPClient.download_file(conn, &quot;my/remote/dir/image.png&quot;, &quot;my/local/dir&quot;) # =&gt; {:ok, &quot;my/local/dir/image.png&quot;}It is also possible to use Streams to download data into a file or memory.source_stream = SFTPClient.stream_file!(conn, &quot;my/remote/file.jpg&quot;) target_stream = File.stream!(&quot;my/local/file.jpg&quot;) source_stream |&gt; Stream.into(target_stream) |&gt; Stream.run()UploadTo upload are file from the file system you can use the following function.SFTPClient.upload_file(conn, &quot;my/local/dir/file.jpg&quot;, &quot;my/remote/dir/file.jpg&quot;) # =&gt; {:ok, &quot;my/remote/dir/file.jpg&quot;}You can also use Streams to upload data. Please make sure to set a proper chunk size or the upload may be very slow.source_stream = File.stream!(&quot;my/local/file.jpg&quot;, [], 32_768) target_stream = SFTPClient.stream_file!(conn, &quot;my/remote/file.jpg&quot;) source_stream |&gt; Stream.into(target_stream) |&gt; Stream.run()List DirectorySFTPClient.list_dir(conn, &quot;my/dir&quot;) # =&gt; {:ok, [&quot;my/dir/file_1.jpg&quot;, &quot;my/dir/file_2.jpg&quot;, ...]}Create DirectorySFTPClient.make_dir(conn, &quot;my/new/dir&quot;)Note that this operation fails unless the parent directory exists.DeleteTo delete a file:SFTPClient.delete_file(conn, &quot;my/remote/file.jpg&quot;)To delete a directory:SFTPClient.delete_dir(conn, &quot;my/remote/dir&quot;)Note that a directory cannot be deleted as long as it still contains files.RenameTo move/rename a file or directory:SFTPClient.rename(conn, &quot;my/remote/file.jpg&quot;, &quot;my/remote/new-file.jpg&quot;)File InfoYou can retrieve meta data about a file from the server such as file size, modification time, file permissions, owner and so on.SFTPClient.file_info(conn, &quot;my/remote/file.jpg&quot;) # =&gt; {:ok, %File.Stat{...}}Refer to the File.Stat docs for a list of available file information.Symbolic LinksThere are also a couple of functions that handle symlinks.It is possible to get the target of a symlink.SFTPClient.read_link(conn, &quot;my/remote/link.jpg&quot;) # =&gt; {:ok, &quot;my/remote/file.jpg&quot;}You can retrieve meta data about symlinks, similar to file_info/2.SFTPClient.link_info(conn, &quot;my/remote/link.jpg&quot;) # =&gt; {:ok, %File.Stat{...}}And you are able to create symlinks.SFTPClient.make_link(conn, &quot;my/remote/link.jpg&quot;, &quot;my/remote/file.jpg&quot;)","ref":"readme.html#usage","title":"SFTP Client - Usage","type":"extras"},{"doc":"Documentation can be generated with ExDoc and published on HexDocs. Once published, the docs can be found at https://hexdocs.pm/sftp_client.","ref":"readme.html#docs","title":"SFTP Client - Docs","type":"extras"}]